import { AuthType } from "../enums/AuthType";
import { ConnectionType } from "../enums/ConnectionType";
import { NodeTrustedMailcore2NativeBinding } from "../types/NodeTrustedMailcore2NativeBinding";
import { IMAPAsyncSessionNativeBinding } from '../types';
declare let bindings: NodeTrustedMailcore2NativeBinding;
/**
 * IMAPAsyncSession Class
 *
 * @public
 */
declare class IMAPAsyncSession extends bindings.IMAPAsyncSession {
    protected handle: IMAPAsyncSessionNativeBinding;
    constructor();
    /**
     * Set hostname
     *
     * @memberof IMAPAsyncSession
     */
    set hostname(hostname: string);
    /**
     * Get hostname
     *
     * @type {string}
     * @memberof IMAPAsyncSession
     */
    get hostname(): string;
    /**
     * Set port
     *
     * @memberof IMAPAsyncSession
     */
    set port(port: number);
    /**
     * Get port
     *
     * @type {number}
     * @memberof IMAPAsyncSession
     */
    get port(): number;
    /**
     * Set string
     *
     * @memberof IMAPAsyncSession
     */
    set username(username: string);
    /**
     * Get string
     *
     * @type {string}
     * @memberof IMAPAsyncSession
     */
    get username(): string;
    /**
     * Set password
     *
     * @memberof IMAPAsyncSession
     */
    set password(password: string);
    /**
     * Get password
     *
     * @type {string}
     * @memberof IMAPAsyncSession
     */
    get password(): string;
    /**
     * Set checkCertificateEnabled
     *
     * @memberof IMAPAsyncSession
     */
    set checkCertificateEnabled(isEnabled: boolean);
    /**
     * Get checkCertificateEnabled
     *
     * @type {boolean}
     * @memberof IMAPAsyncSession
     */
    get checkCertificateEnabled(): boolean;
    /**
     * Set OAuth2Token
     *
     * @memberof IMAPAsyncSession
     */
    set OAuth2Token(OAuth2Token: string);
    /**
     * Get OAuth2Token
     *
     * @type {string}
     * @memberof IMAPAsyncSession
     */
    get OAuth2Token(): string;
    /**
     * Set authType
     *
     * @memberof IMAPAsyncSession
     */
    set authType(authType: AuthType);
    /**
     * Get authType
     *
     * @type {AuthType}
     * @memberof IMAPAsyncSession
     */
    get authType(): AuthType;
    /**
     * Set connectionType
     *
     * @memberof IMAPAsyncSession
     */
    set connectionType(connectionType: ConnectionType);
    /**
     * Get connectionType
     *
     * @type {ConnectionType}
     * @memberof IMAPAsyncSession
     */
    get connectionType(): ConnectionType;
    /**
     * Validate exist account
     *
     * @param {string} from address
     * @returns {number} 0 - success, other - failure
     *
     * @memberof IMAPAsyncSession
     */
    checkAccount(from: string): Promise<number>;
    /**
     * Disconnect connection
     *
     * @memberof IMAPAsyncSession
     */
    disconnect(): void;
    /**
     * Validate connection status
     *
     * @returns {boolean}
     *
     * @memberof IMAPAsyncSession
     */
    isDisconnected(): boolean;
    fetchAllFolders(): any;
}
export { IMAPAsyncSession };
//# sourceMappingURL=IMAPAsyncSession.d.ts.map